<?php
class cssource {
var $ip;
var $port;
var $timeout;
var $sock;
var $data;
var $output = array();
var $sortBy;
var $connerr;

function cssource($ip, $port="", $timeout=60) {
$this->ip = $ip;
$this->port = (empty($port)) ? 27015 : $port;
$this->timeout = $timeout;
}

function get_challenge()
{
socket_set_timeout($this->sock, 2);
// get challenge number from server
fwrite($this->sock, "\xFF\xFF\xFF\xFF\x57");
$challenge = fread($this->sock, 4096);
$challenge = substr($challenge, 5, 4);
return $challenge;
}

function status() {
if(@!$this->sock = fsockopen("udp://".$this->ip, $this->port, $errno, $errstr, 60)) {
$this->connerr=1;
}

else {
$this->connerr=0;
$querys[] = "\xFF\xFF\xFF\xFFTSource Engine Query\x00";
$challenge = $this->get_challenge($this->sock);
$querys[] = "\xFF\xFF\xFF\xFF\x55" . $challenge;
$querys[] = "\xFF\xFF\xFF\xFF\x56" . $challenge;

$wait = 0;
foreach($querys AS $querystring) {
fwrite($this->sock, $querystring);
while($wait < $this->timeout) {
$string = fread($this->sock, 4096);
$wait += 10;

if(!empty($string)) {
$this->data[] = $string;
if(strlen($string) < 4096)
break;
}
}
}
@fclose($this->sock);

if(empty($this->data[0]))
$this->connerr=1;

$this->parseStatus();
$this->parseRules();
return $this->output;
}
}

function parseStatus() {
$status = $this->data[0];
$i = 5;

$this->output['net_protocol'] = ord($status{$i++});
$this->output['ip'] = $this->ip;
$this->output['port'] = $this->port;
$this->output['hostname'] = $this->readString($status, $i);
$this->output['map'] = $this->readString($status, $i);
$this->output['game_dir'] = $this->readString($status, $i);
$this->output['game_type'] = $this->readString($status, $i);
$this->output['appid'] = ord($status{$i++}.$status{$i++});
$this->output['num_players'] = ord($status{$i++});
$this->output['max_players'] = ord($status{$i++});
$this->output['bot_players'] = ord($status{$i++});
$this->output['dedicated'] = $status{$i++};
$this->output['server_os'] = $status{$i++};
$this->output['needpass'] = ord($status{$i++});
$this->output['secure'] = ord($status{$i++});

return TRUE;
}

function parseRules() {
$rules = $this->data[2];
$rule = explode("\x00", $rules);
$num_rules = count($rule);

for($i = 2; $i < $num_rules; $i+=2)
$this->output['rules'][$rule[$i-1]] = $rule[$i];

return TRUE;
}

function readString($string, &$i) {
$begin = $i;
$strlen = strlen($string);
for ($i; ($i < $strlen) && ($string{$i} != chr(0)); $i++);
$result = substr($string, $begin, $i-$begin);
$i++;

return $result;
}

function sortPlayers($sortvar="index") {
$players = $this->output['players'];
$num_players = count($players);

for($i = 0; $i != $num_players; $i++) {
$a = $i;
$b = $num_players-1;
while ($a != $b){
if ($players[$a][$sortvar] > $players[$b][$sortvar])
$b--;
else
$a++;
}
$h = $players[$i];
$players[$i] = $players[$a];
$players[$a] = $h;
}
$this->output['players'] = $players;

return TRUE;
}

function setSortBy($sortvar) {
$this->sortBy = $sortvar;
}
}
?>